
% cd ~/fin_frictions/matlab/bonds
% addpath ..
clear all; rng shuffle; 
% addpath ~/fin_frictions/matlab/JPT_files

cd '~/FinFrictions/bonds'
addpath ..


warning('off','MATLAB:nearlySingularMatrix')
warning('off','MATLAB:illConditionedMatrix')

load data_bonds
T=length(y);

load -ascii XOUT14_bonds.txt
xout=XOUT14_bonds; xout2=sortrows(xout,1);

% load counter; counter=counter+1; save counter counter;
counter=1;

x0=xout2(counter,2:end);
% % 
% x0(1)=-1.7; x0(2)=-.46; x0(end-1)=3.4;

% get standard deviation of prior here
% hess=.1*diag(hess/mean(hess));
% H=hess;

% posterior mode is the point with the highest posterior
% jacobian comes from jacob_JPT
xh=x0;
postmode=bounds14_bonds(xh);

% HH=H;

%%% get the distribution:
aa=zeros(1000,length(x0));
i=1;
while i<=1000
    test=bounds14_bondsINV(random_full14_bonds());
    if isreal(test); aa(i,:)=test; i=i+1; end
end

aa(:,16)=aa(:,15);

hess=diag(std(aa));



% preliminaries for the MCMC algorithm
const=.0015;        % scaling constant for the inverse Hessian
M=100000;          % length of each of the two chains
N=200;          % number of discarded draws at the beginning of each chain


% Metropolis algorithm
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic

    P1=zeros(M,length(x0));
    post1=zeros(M,1);
    post1(1)=-logpost_bonds_14(x0,T,y);
    P1(1,:)=x0;
    logpostOLD=post1(1);
    
    count=0; num=0;
    start=2;
    
    VV=diag(var(aa));
    sd = (2.38^2)/100000;
    
%     out=[post1 P1];
%     eval(['save CHAIN_long', num2str(counter), ' out i'])
    
%     load CHAIN_long1
%     start=i-1;
%     post1=out(:,1);
%     P1=out(:,2:end);
%     sd=3;
%     VV=cov(P1(1:i-1,:));
    
    % see http://www.jstor.org/pss/3318737
    
    for i=start:M
        
        P1(i,:)=mvnrnd(P1(i-1,:),VV*sd);
        tester=P1(i,:);
        logpostNEW=-logpost_bonds_14(...
            tester,T,y);
        if logpostNEW>logpostOLD
            logpostOLD=logpostNEW;
            count=count+1;
        else
            if rand(1)<exp(logpostNEW-logpostOLD);
                logpostOLD=logpostNEW;
                count=count+1;
            else
                P1(i,:)=P1(i-1,:);
            end
        end
        post1(i)=logpostOLD;
        
        % update variance
        if i==200*floor(i/200) & i>=500;
            if i==500; sd=(2.38^2); end
            VV=cov(P1(1:i,:));
            
            % take just the first few eigenvalues
            [VVv,VVd]=eig(VV);
            VVd=diag(VVd);
            VVd(1:end-10)=0*VVd(1:end-10);
            VV2=VVv*diag(VVd)*inv(VVv);
            VV=VV2;
            
            if count/num<.05
                sd=sd/3
            elseif count/num<.1
                sd=sd/1.5
            elseif count/num<.15
                sd=sd/1.25
            elseif count/num>.8
                sd=sd*10
            elseif count/num>.5
                sd=sd*3
            elseif count/num>.3
                sd=sd*1.5
            end
            
            count=0; num=0;
            out=[post1 P1];
            eval(['save CHAIN_long', num2str(counter), ' out i'])
            
        end
        
        

        disp([num2str(i) '   ' num2str(count/num) '   ' ...
            num2str(logpostOLD) '   ' num2str(logpostNEW) ...
             '   ' num2str(toc)]);
        
        num=num+1;
        
    end


toc


