function [shatnew,signew,loglh,L1,L2]=kfilter(y,H,C,F,shat,sig,R,Q) %#codegen

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MODEL
% y(t)=C+H*s(t)+e(t)
% s(t)=F*s(t-1)+v(t)
% V(e(t))=R
% V(v(t))=Q
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=length(y);
omega=F*sig*F'+Q;
sigma=H*omega*H'+R;
k=omega*H'/sigma; 

shatnew=F*shat+k*(y-C-H*F*shat);
signew=omega-k*H*omega;

loglh=-.5*log(det(sigma))-.5*((y-C-H*F*shat)'/sigma)*(y-C-H*F*shat)-.5*n*log(2*pi);


L1=-.5*log(det(sigma(1:6,1:6)))-.5*((y(1:6)-C(1:6)-H(1:6,:)*F*shat)'/sigma(1:6,1:6))*(y(1:6)-C(1:6)-H(1:6,:)*F*shat)-.5*n*log(2*pi);
L2=-.5*log(det(sigma(7:end,7:end)))-.5*((y(7:end)-C(7:end)-H(7:end,:)*F*shat)'/sigma(7:end,7:end))*(y(7:end)-C(7:end)-H(7:end,:)*F*shat)-.5*n*log(2*pi);

