function [logpost,coe_C_old,coe_Z_old]=logpost_full12(param,T,y);

param=bounds14_bonds(param);

RHO=.75;

alpha=.33;
gamma100=.47; gamma=gamma100/100;
Fbeta=0.35;
beta=100/(Fbeta+100); lbeta=log(beta);
betaI=1/(1-beta);   

pdbar=-log(1-exp(lbeta+(1-RHO)*gamma));

pss=2.5/400;
% prior density


logprior=logprior_full14_bonds(param);
param(25)=param(25)*param(28);

ALPHA=param(28);
Z_bar=(1-ALPHA)/(1-RHO);

%%%%%%%%%%%%%%%%!!!!!!!!!!!!!!!!!!!!!!!!!!!!
param(25)=param(25)*sqrt(1-param(16)^2);
param(26)=param(26)-.5;

param(4)=0;
param(33)=0;

% param(23)=0;
% param(25)=0;
%%%%%%%%%%%%%%%%!!!!!!!!!!!!!!!!!!!!!!!!!!!!

% param(end)=.000001;

% posterior calculation
if logprior==-1e10 | ~isreal(pdbar)
    logpost=1e20;
    return    
else
    % Solution of the model
        [G1,C,M,eu,SDX,H,rbar,B,~,~,Br]=model_full14_bonds(param);
%         disp(eu')

    if sum(eu) ~=2;
        logpost=1e20;
        return
    else
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % get bond prices
        %% note that the constant is included for Z, but not the inflation target
        
        PHI=G1;
        PSI=M;
        
        NY=length(G1);
             
        H=[H(1:7,:); B([20 4 8 12 16 40 80],:)]; 
        C=[C(1:7); zeros(7,1)];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        if isreal(C)&&isreal(H)&&isreal(G1)&&isreal(M)
        
            % initializing the Kalman filter
            SS=(G1^10000)*[ones(NY-1,1);1];
            shat=SS;
%             SDX(8,2)=0;
            Q=M*SDX*SDX'*M';
            sig=disclyap_fast(G1,Q);
            LOGLH=0;
            
            Q(end,:)=0; Q(:,end)=0;
            
%             SS([8,[14:17]])

            % Kalman filter recursion delivering log-likelihood
            x=shat;
            R=zeros(14,14);
            
            R(8:14,8:14)=(param(29).^2)*(diag([20 4 8 12 16 40 80]/4).^2);
            
            for t=1:T
                [shat,sig,loglh]=kfilter(y(t,:)',H,C,G1,shat,sig,R,Q);
                LOGLH=LOGLH+loglh;
                LL(t)=loglh;
                x=[x shat];
            end
            
%             plot([-B(1,:)*x; H(7,:)*x+C(7)]')
            
            slope=-400*(B(40,:)/40-B(1,:))*SS;
            pr_slope=log(normpdf(slope,2,.1));
            
            slope2=-400*(B(20,:)/20-B(1,:))*SS;
            pr_slope2=log(normpdf(slope2,1,.15));
%             
            sloper=-400*(Br(40,:)/40-Br(1,:))*SS;
            pr_sloper=log(normpdf(sloper,0,.2));
            
%             disp([slope slope2 sloper])

%             plot(400*x(22,2:end)-20)

%             disp(LOGLH)
            logpost=-(LOGLH+logprior+...
                pr_slope);      % logpost = -logpost because use a minimization algorithm (as opposed to maximization)
            if imag(logpost)~=0; logpost=1e20; end
        else
            logpost=1e20;
        end
    end
end

% disp(logpost);
