function [logprior prior_long] = logprior_full(param);

prior = zeros(length(param),1);

prior(1)  = logBetapdf(param(1),0.3,0.1);          % iotap
prior(2)  = logBetapdf(param(2),0.3,0.1);          % iotaw
prior(3)  = logBetapdf(param(3),0.5,0.2);           % h
prior(4) = 0;        % Fbeta
prior(5) = logGammapdf(param(5),5,3);             % S
prior(6) = log(normpdf(param(6),1.6,.3));        % fp
prior(7) = logGammapdf(param(7),.15,0.03);       % fy
prior(8) = log(normpdf(param(8),0.15,0.1));     % fdy
 
prior(9) = logBetapdf(param(9),0.75,0.1);          % rhoR
prior(10) = log((param(10)>-1)*(param(10)<1));          % rhoz
prior(11) = logBetapdf(param(11),0.6,0.2);          % rhog    %%%%%%%%%
prior(12) = logBetapdf(param(12),0.6,0.2);          % rhomiu
prior(13) = logBetapdf(param(13),0.6,0.2);          % rholambdap
prior(14) = logBetapdf(param(14),0.6,0.2);          % rholambdaw
prior(15) = logBetapdf(param(15)/.85,0.5,0.1);          % rhob
prior(16) = logBetapdf(param(16),0.8,0.1);          % rhoz

prior(17) = log(normpdf(param(17),0.1,1));             % sdR
prior(18) = logIG1pdf(param(18),1.5,2);             % sdz
prior(19) = logIG1pdf(param(19),0.5,1);             % sdg
prior(20) = logIG1pdf(param(20),0.5,.5);             % sdmiu

sd_p = sqrt((1-param(13)*param(31) + (param(31)^2))/(1-param(13)^2))*param(21);
sd_w = sqrt((1-param(14)*param(32) + (param(32)^2))/(1-param(14)^2))*param(22);
prior(21) = log(normpdf(sd_p,0.14,.05));             % sdlambdap
prior(22) = log(normpdf(sd_w,0.2,.05));             % sdlambdaw


prior(23) = logIG1pdf(param(23),0.001,0.003);             % sdb
prior(24) = logIG1pdf(...
    sqrt(param(24)^2+param(4)^2+param(27)^2+param(33)^2),...
            0.2,0.2);             % sdPIS
prior(25) = 0;             % sdRRA


prior(26)=0;
prior(27)=0;

prior(28) = log((param(28)>2)*normpdf(param(28),7,5)); %logIG1pdf(param(46),25,20);   % ALPHA

prior(29) = 0;  % err

prior(30) = log(normpdf((param(18)/(1-param(10))),1.25,.35));

prior(31)=logBetapdf(param(31),.7,.15);
prior(32)=logBetapdf(param(32),.7,.15);

param(33)=0;

prior_long=prior;
if all(isfinite(prior))==0 | all(isreal(prior))==0;
    logprior=-1e10;
else
    logprior=sum(prior);
end